from edge.webserver.sysconf.uiref import UiRef


def create_unit__media_server__media(unit_name, react_dir):
    """
    :type unit_name: str
    :type react_dir: str

    :rtype: str, dict
    """

    uiref = UiRef(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_edge', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': {
                    'endpoint': react_dir
                }
            }
        ]
    }


def create_unit__event_emitter__tx_track_bus(unit_name, translate_plate, blob_endpoint, args_endpoint):
    """
    :type unit_name: str
    :type translate_plate: bool
    :type blob_endpoint: str
    :type args_endpoint: str

    :rtype: str, dict
    """

    uiref = UiRef(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_edge', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': {
                    'translate-plate': translate_plate,
                    'store': {
                        'endpoint': blob_endpoint,
                        'min-file-count': 20,
                        'max-file-count': 25
                    },
                    'track': [
                        args_endpoint
                    ]
                }
            }
        ]
    }


def create_unit__event_emitter__tx_scene_bus(unit_name, endpoints):
    """
    :type unit_name: str
    :type endpoints: list of str

    :rtype: str, dict
    """

    uiref = UiRef(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_edge', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': {
                    'scene': endpoints
                }
            }
        ]
    }
