from edge.com import fs, net
from edge.webserver.sysconf.uiref import UiRef


def create_unit__essentials__api(unit_name, term_ref):
    """
    :type unit_name: str
    :type term_ref: str

    :rtype: str, dict
    """

    uiref = UiRef(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_essentials', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': 'api',
                'name': uiref.ref,
                'conf': {
                    'endpoint': net.get_lr_uds_endpoint(term_ref)
                }
            }
        ]
    }


def create_unit__essentials__counters(unit_name, spool_path):
    """
    :type unit_name: str
    :type spool_path: str

    :rtype: str, dict
    """

    uiref = UiRef(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_essentials', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': 'counters',
                'name': uiref.ref,
                'conf': {
                    'stat-path': fs.join_path(spool_path, 'zabbix', 'lr0'),
                    'stat-tout': 3
                }
            }
        ]
    }
