from edge.webserver.sysconf.uiref import UiRef


def create_unit__speedcam___speedcam(unit_name, pri_conf, intrinsics, extrinsics):
    """
    :type unit_name: str
    :type pri_conf: dict
    :type intrinsics: str
    :type extrinsics: str

    :rtype: str, dict
    """

    uiref = UiRef(unit_name)
    parent_uiref = uiref.parent

    limits_jnode = pri_conf.get('speedcam-limits') or {
        'min-track-size': 5,
        'with-const-plate-u': 1,
        'const-plate-u': 0.5,
        'min-plate-u': 0.0,
        'max-plate-u': 2.0
    }

    return unit_name, {
        'bundle': ['libunity_speedcam', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': {
                    'camera': {
                        'intrinsics': intrinsics,
                        'extrinsics': extrinsics
                    },
                    'limits': limits_jnode
                }
            }
        ]
    }
