from edge.webserver.sysconf.uiref import UiRef


def create_unit__wiegand___pcb(unit_name, wiegand_conf):
    """
    :type unit_name: str
    :type wiegand_conf: dict

    :rtype: str, dict
    """

    uiref = UiRef(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_wiegand', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': wiegand_conf
            }
        ]
    }


def create_unit__wiegand___udp(unit_name, wiegand_conf):
    """
    :type unit_name: str
    :type wiegand_conf: dict

    :rtype: str, dict
    """

    uiref = UiRef(unit_name)
    parent_uiref = uiref.parent

    return unit_name, {
        'bundle': ['libunity_wiegand', '1.0.0'],
        'type': parent_uiref.type,
        'name': parent_uiref.ref,
        'units':
        [
            {
                'type': uiref.type,
                'name': uiref.ref,
                'conf': wiegand_conf
            }
        ]
    }
